﻿--变量
local id = 1;
local _G = _G;

--队友施法条
for id = 1, 4, 1 do
    local UFPPartyCastbar = CreateFrame("StatusBar", "UFP_PartyCastbar"..id, _G["PartyMemberFrame"..id]);
    UFPPartyCastbar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar");
    UFPPartyCastbar:SetStatusBarColor(1.0, 0.7, 0.0);
    UFPPartyCastbar:SetWidth(90);
    UFPPartyCastbar:SetHeight(10);
    UFPPartyCastbar:ClearAllPoints();
    UFPPartyCastbar:SetID(id);
    UFPPartyCastbar:SetFrameStrata("MEDIUM");
    RaiseFrameLevel(UFPPartyCastbar);

    UFPPartyCastbar.Background = UFPPartyCastbar:CreateTexture("UFP_PartyCastbar"..id.."Background", "BACKGROUND");
    UFPPartyCastbar.Background:SetAllPoints(true);
    UFPPartyCastbar.Background:SetVertexColor(0, 0, 0, 0.5);

    UFPPartyCastbar.Border = UFPPartyCastbar:CreateTexture("UFP_PartyCastbar"..id.."Border", "BORDER");
    UFPPartyCastbar.Border:SetTexture("Interface\\CastingBar\\UI-CastingBar-Border-Small");
    UFPPartyCastbar.Border:SetWidth(126);
    UFPPartyCastbar.Border:SetHeight(48);
    UFPPartyCastbar.Border:ClearAllPoints();
    UFPPartyCastbar.Border:SetPoint("TOP", UFPPartyCastbar, "TOP", 0, 20);

    UFPPartyCastbar.Text = UFPPartyCastbar:CreateFontString("UFP_PartyCastbar"..id.."Text", "ARTWORK", "GameFontHighlight");
    UFPPartyCastbar.Text:SetTextHeight(13);
    UFPPartyCastbar.Text:ClearAllPoints();
    UFPPartyCastbar.Text:SetPoint("TOP", UFPPartyCastbar, "TOP", 0, 2);

    UFPPartyCastbar.Icon = UFPPartyCastbar:CreateTexture("UFP_PartyCastbar"..id.."Icon", "ARTWORK");
    UFPPartyCastbar.Icon:SetWidth(16);
    UFPPartyCastbar.Icon:SetHeight(16);
    UFPPartyCastbar.Icon:ClearAllPoints();
    UFPPartyCastbar.Icon:SetPoint("RIGHT", UFPPartyCastbar, "LEFT", -5, 0);

    UFPPartyCastbar.Spark = UFPPartyCastbar:CreateTexture("UFP_PartyCastbar"..id.."Spark", "OVERLAY");
    UFPPartyCastbar.Spark:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark");
    UFPPartyCastbar.Spark:SetWidth(32);
    UFPPartyCastbar.Spark:SetHeight(32);
    UFPPartyCastbar.Spark:ClearAllPoints();
    UFPPartyCastbar.Spark:SetPoint("CENTER", UFPPartyCastbar, "CENTER", 0, 0);
    UFPPartyCastbar.Spark:SetBlendMode("ADD");

    UFPPartyCastbar.Flash = UFPPartyCastbar:CreateTexture("UFP_PartyCastbar"..id.."Flash", "OVERLAY");
    UFPPartyCastbar.Flash:SetTexture("Interface\\CastingBar\\UI-CastingBar-Flash-Small");
    UFPPartyCastbar.Flash:SetWidth(126);
    UFPPartyCastbar.Flash:SetHeight(48);
    UFPPartyCastbar.Flash:ClearAllPoints();
    UFPPartyCastbar.Flash:SetPoint("TOP", UFPPartyCastbar, "TOP", 0, 20);
    UFPPartyCastbar.Flash:SetBlendMode("ADD");

    CastingBarFrame_OnLoad(UFPPartyCastbar, "party"..id, true, false);
end

function UnitFramesPlus_PartyCastbar()
    for id = 1, 4, 1 do
        if UnitFramesPlusDB["party"]["origin"] == 1 and UnitFramesPlusDB["party"]["castbar"] == 1 then
            _G["UFP_PartyCastbar"..id]:SetAlpha(1);
            _G["UFP_PartyCastbar"..id]:SetScript("OnEvent", function(self, event, ...)
                CastingBarFrame_OnEvent(self, event, ...);
            end)
            _G["UFP_PartyCastbar"..id]:SetScript("OnUpdate", function(self, elapsed)
                CastingBarFrame_OnUpdate(self, elapsed);
            end)
            _G["UFP_PartyCastbar"..id]:SetScript("OnShow", function(self)
                CastingBarFrame_OnShow(self);
                self:ClearAllPoints();
                if (_G["PartyMemberFrame"..self:GetID().."PetFrame"]:IsShown()) then
                    self:SetPoint("BOTTOM", self:GetParent(), "BOTTOM", 6, -27);
                else
                    self:SetPoint("BOTTOM", self:GetParent(), "BOTTOM", 6, -12);
                end
            end);
        else
            _G["UFP_PartyCastbar"..id]:SetAlpha(0);
            _G["UFP_PartyCastbar"..id]:SetScript("OnEvent", nil);
            _G["UFP_PartyCastbar"..id]:SetScript("OnUpdate", nil);
            _G["UFP_PartyCastbar"..id]:SetScript("OnShow", nil);
        end
    end
end

function UnitFramesPlus_PartyCastbarInit()
    UnitFramesPlus_PartyCastbar();
end
